#! /usr/bin/python

from gtk import *
import os, string, re, contact, category, money, GtkExtra


class bank:
    def __init__(self):
        self.window = GtkWindow(WINDOW_TOPLEVEL)
        self.window.connect("delete_event",self.quit)
        self.window.set_title("Bank v0.01")
        wscr=screen_width()
        hscr=screen_height()
        
        if wscr>350:
            wscr=350
        if hscr>350:
            hscr=350
        self.window.set_usize(wscr,hscr)

        self.get_config()
        self.money = money.Money(self)
        self.contacts = contact.Contacts(self)
        self.categories = category.Categories(self)

        # VBox principal
        self.vbox = GtkVBox()
        self.window.add(self.vbox)
        self.vbox.show()

        # Menu Bar
    
        ag = GtkAccelGroup()
        itemf = GtkItemFactory(GtkMenuBar, "<main>", ag)
        self.window.add_accel_group(ag)
        itemf.create_items([
            ('/_File',          None,         None, 0, '<Branch>'),
            ('/_File/_Import',     None, self.not_yet, 1, ''),
            ('/_File/_Export',    None, self.not_yet, 2, ''),
            ('/_File/sep1',     None,   None, 0, '<Separator>'),
            ('/_File/E_xit',    '<alt>F4',    self.quit, 6, ''),
            ('/_Help',          None,         None, 0, '<LastBranch>'),
            ('/_Help/_About',   '<control>A', self.show_about, 1, '')
        ])
        self.w_menubar = itemf.get_widget('<main>')
        self.vbox.pack_start(self.w_menubar, expand=FALSE)
        self.w_menubar.show()
    

        # make the toolbar
        self.toolbar = GtkToolbar(ORIENTATION_HORIZONTAL, TOOLBAR_ICONS)
        self.toolbar.set_button_relief(RELIEF_NONE)
        self.toolbar.set_space_size(10)
        self.vbox.pack_start(self.toolbar, expand=FALSE)
        self.toolbar.show()
        
        # make our notbook
        self.notebook = GtkNotebook()
        self.notebook.show()
        self.notebook.set_show_tabs(FALSE)
        self.notebook.set_show_border(FALSE)
        # add it to the vbox
        self.notebook.add(self.money.frame)
        self.notebook.add(self.contacts.frame)
        self.notebook.add(self.categories.frame)
        self.vbox.pack_start(self.notebook)
        
        pix, mask = create_pixmap_from_xpm(self.window, None, self.config[2] + "/pixmaps/money.xpm")
        self.toolbar.append_item(None, 'Money', None, GtkPixmap(pix, mask), self.show_money)
        pix, mask = create_pixmap_from_xpm(self.window, None, self.config[2] + "/pixmaps/evolution-contacts.xpm")
        self.toolbar.append_item(None, 'Contacts', None, GtkPixmap(pix, mask), self.show_contacts)
        pix, mask = create_pixmap_from_xpm(self.window, None, self.config[2] + "/pixmaps/briefcase.xpm")
        self.toolbar.append_item(None, 'Categories', None, GtkPixmap(pix, mask), self.show_categories)

    def show_money(self, *args):
        self.notebook.set_page(0)

    def show_contacts(self, *args):
        self.notebook.set_page(1)

    def show_categories(self, *args):
        self.notebook.set_page(2)

    def show_about(self,*args):
        dlg=GtkExtra.message_box("About Bank",
                     "Bank v0.01\n\n" +
                     "The Bank personal finance manager\n\n"
                     "Author : Medhy Palfray \n"+
                     "Email : <medhy@palfray.com>\n\n" +
                     "(c) 2002 Medhy Palfray", ("OK",),
                     pixmap=self.config[2] + "/pixmaps/money.xpm")

    def not_yet(self,*args):
        dlg=GtkExtra.message_box("Not yet",
                     "Not yet implemented", ("OK",),'')

    def get_config(self):
        # open up the bank config file
        file = open(os.environ['HOME'] + '/.bank', 'r')
        # read it
        lines = file.readlines()
        # assign varivles to the different lines
        self.config = []
        for line in lines:
            line = string.strip(line)
            self.config.append(line)
    
    
    def mainloop(self):
        # Dmarrage de la fenetre
        self.window.show()
        mainloop()

    def quit(self,*args):
        # Fermeture de la fenetre
        mainquit()


x=bank()
x.mainloop()

